#-----------------------------------------------------------------
# Module: ai
#   AI specific script stuff
#-----------------------------------------------------------------

import _ai
import goal

#-----------------------------------------------------------------
# The AI class, typically you create one of these by using
# the findAI function
class AI:
    def __init__( self, id ):
        self.id = id

    # add a goal to this ai,
    # optional callback will be called when this goal completes
    # the permanent flag will not allow the goal to complete, and prevent removal by clearGoals()
    def addGoal( self, goal, priority = goal.PRI_ZERO, callback = '', user = 0, permanent = 0 ):
        """Add a goal object to the ai.  See module goal."""
        _ai.addGoal( self.id, goal, priority, callback, user, permanent )

    # remove all non-permanent goals from this ai
    def clearGoals( self ):
        _ai.clearGoals( self.id )

    # remove the permanent natural kill goal.
    def removeNaturalKillGoal( self ):
        _ai.removeNaturalKillGoal( self.id )

#-----------------------------------------------------------------
def findAI( name ):
    """Find an AI object based on name"""
    return AI( _ai.findObject(name) )

#-----------------------------------------------------------------
def addGoalToAI( name, goal, priority = goal.PRI_ZERO, callback = '', user = 0, permanent = 0, replace = 1 ):
    ai = findAI(name)
    if replace:
        ai.clearGoals()
    ai.addGoal(goal,priority,callback,user,permanent)

