#-----------------------------------------------------------------
# Module: goal
#   goal creation helpers
#-----------------------------------------------------------------

import _ai

#-----------------------------------------------------------------
# Goal priorities

PRI_ZERO = _ai.PRI_ZERO
PRI_LOW = _ai.PRI_LOW
PRI_MED = _ai.PRI_MED
PRI_HI = _ai.PRI_HI
PRI_ALWAYS = _ai.PRI_ALWAYS

#-----------------------------------------------------------------
# Goal generators

def Move( dest, command = 'move', radius = 1.0, speed = 0.0 ):
    return ('CMoveGoal',( dest, command, radius, speed ) )

def Wander():
    return ('CWanderGoal', '' )

def Null():
    return ('CNullGoal', '' )

def CollectThrowable( object ):
    return CollectObjToObjectList( AttackThrowableList(), object)

def CollectObjToObjectList( attacklist, object ):
    return ('CCollectObjToObjectGoal', attacklist, object )
def CollectObjToPointList( attacklist, point ):
    return ('CCollectObjToPointGoal', attacklist, point )


def KillClass( classFlags ):
    return ('CKillGoal', AttackClassList(classFlags) )

def KillObjectsTuple( names ):
    return ('CKillGoal', AttackObjectList(names) )

def KillObjects( *names ):
    return ('CKillGoal', AttackObjectList(names) )

def KillBuildings():
    return ('CKillGoal', AttackBuildingList() )

def CollectThrowableToObject(object):
    return ('CCollectObjGoal', (object, (0,0,0)) )

def CollectThrowableToPoint(point):
    return ('CCollectObjGoal', ('', point) )

def RoutObjectsTuple( names ):
    return ('CRoutGoal', AttackObjectList(names) )

def RoutObjects( *names ):
    return ('CRoutGoal', AttackObjectList(names) )


#-----------------------------------------------------------------
# Attack list generators, advanced users only...

def KillList( attacklist ):
    return ('CKillGoal', attacklist )

def RoutList( attacklist ):
    return ('CRoutGoal', attacklist )

def AttackClassList( classFlags ):
    return ('CAttackClassList', classFlags )

def AttackObjectList( names ):
    return ('CAttackObjectList', names )

def AttackBuildingList():
    return ('CAttackBuildingList', None )

def AttackThrowableList():
    return ('CAttackThrowableList', None )
