#
# SoundHandle python class wrappers
# Author: Glenn "Gaffer" Fiedler
# (10 out of 10 for cuteness =p)
#

import js


class Sound:

	def __init__(self, name):
		self.handle = js.Sound_CreateSound_HANDLE(name)

	def play(self):
		return js.Sound_PlaySound_HANDLE(self.handle)

	def loop(self):
		return js.Sound_LoopSound_HANDLE(self.handle)

	def endloop(self):
		return js.Sound_EndLoopSound_HANDLE(self.handle)

	def position(self, tuple):
		return js.Sound_SetSoundPosition_HANDLE(self.handle, tuple)

	def velocity(self, tuple):
		return js.Sound_SetSoundPosition_HANDLE(self.handle, tuple)

	def volume(self, gain):
		return js.Sound_SetSoundGain_HANDLE(self.handle, gain)

	def playing(self):
		return js.Sound_IsSoundPlaying_HANDLE(self.handle)

	def stop(self):
		return js.Sound_StopSound_HANDLE(self.handle)

	def release(self):
		return js.Sound_ReleaseSound_HANDLE(self.handle)

	def debug(self):
		print self.handle[0]
		print self.handle[1]



def load(name):
	return Sound(name)
